KUBERNETES(1)(kubernetes)

Eric Paris Jan 2015

NAME
kube-scheduler -

SYNOPSIS
kube-scheduler [OPTIONS]

DESCRIPTION
The Kubernetes scheduler is a control plane process which assigns Pods to Nodes. The scheduler determines which Nodes are valid placements for each Pod in the scheduling queue according to constraints and available resources. The scheduler then ranks each valid Node and binds the Pod to a suitable Node. Multiple different schedulers may be used within a cluster; kube-scheduler is the reference implementation. See scheduling ⟨https://kubernetes.io/docs/concepts/scheduling-eviction/⟩ for more information about scheduling and the kube-scheduler component.

OPTIONS
--allow-metric-labels=[]
    The map from metric-label to value allow-list of this label. The key's format is ,. The value's format is ,...e.g. metric1,label1='v1,v2,v3', metric1,label2='v1,v2,v3' metric2,label1='v1,v2,v3'.

--allow-metric-labels-manifest=""
    The path to the manifest file that contains the allow-list mapping. The format of the file is the same as the flag --allow-metric-labels. Note that the flag --allow-metric-labels will override the manifest file.

--authentication-kubeconfig=""
    kubeconfig file pointing at the 'core' kubernetes server with enough rights to create tokenreviews.authentication.k8s.io. This is optional. If empty, all token requests are considered to be anonymous and no client CA is looked up in the cluster.

--authentication-skip-lookup=false
    If false, the authentication-kubeconfig will be used to lookup missing authentication configuration from the cluster.

--authentication-token-webhook-cache-ttl=10s
    The duration to cache responses from the webhook token authenticator.

--authentication-tolerate-lookup-failure=true
    If true, failures to look up missing authentication configuration from the cluster are not considered fatal. Note that this can result in authentication that treats all requests as anonymous.

--authorization-always-allow-paths=[/healthz,/readyz,/livez]
    A list of HTTP paths to skip during authorization, i.e. these are authorized without contacting the 'core' kubernetes server.

--authorization-kubeconfig=""
    kubeconfig file pointing at the 'core' kubernetes server with enough rights to create subjectaccessreviews.authorization.k8s.io. This is optional. If empty, all requests not skipped by authorization are forbidden.

--authorization-webhook-cache-authorized-ttl=10s
    The duration to cache 'authorized' responses from the webhook authorizer.

--authorization-webhook-cache-unauthorized-ttl=10s
    The duration to cache 'unauthorized' responses from the webhook authorizer.

--bind-address=0.0.0.0
    The IP address on which to listen for the --secure-port port. The associated interface(s) must be reachable by the rest of the cluster, and by CLI/web clients. If blank or an unspecified address (0.0.0.0 or ::), all interfaces and IP address families will be used.

--cert-dir=""
    The directory where the TLS certs are located. If --tls-cert-file and --tls-private-key-file are provided, this flag will be ignored.

--client-ca-file=""
    If set, any request presenting a client certificate signed by one of the authorities in the client-ca-file is authenticated with an identity corresponding to the CommonName of the client certificate.

--config=""
    The path to the configuration file.

--contention-profiling=true
    DEPRECATED: enable block profiling, if profiling is enabled. This parameter is ignored if a config file is specified in --config.

--disable-http2-serving=false
    If true, HTTP2 serving will be disabled [default=false]

--disabled-metrics=[]
    This flag provides an escape hatch for misbehaving metrics. You must provide the fully qualified metric name in order to disable it. Disclaimer: disabling metrics is higher in precedence than showing hidden metrics.

--emulated-version=[]
    The versions different components emulate their capabilities (APIs, features, ...) of. If set, the component will emulate the behavior of this version instead of the underlying binary version. Version format could only be major.minor, for example: '--emulated-version=wardle=1.2,kube=1.31'. Options are: kube=1.32..1.35(default:1.35) If the component is not specified, defaults to "kube"

--feature-gates=
    Comma-separated list of component:key=value pairs that describe feature gates for alpha/experimental features of different components. If the component is not specified, defaults to "kube". This flag can be repeatedly invoked. For example: --feature-gates 'wardle:featureA=true,wardle:featureB=false' --feature-gates 'kube:featureC=true'Options are: kube:APIResponseCompression=true|false (BETA - default=true) kube:APIServerIdentity=true|false (BETA - default=true) kube:APIServingWithRoutine=true|false (ALPHA - default=false) kube:AllAlpha=true|false (ALPHA - default=false) kube:AllBeta=true|false (BETA - default=false) kube:AllowParsingUserUIDFromCertAuth=true|false (BETA - default=true) kube:AllowUnsafeMalformedObjectDeletion=true|false (ALPHA - default=false) kube:AuthorizePodWebsocketUpgradeCreatePermission=true|false (BETA - default=true) kube:CBORServingAndStorage=true|false (ALPHA - default=false) kube:CPUManagerPolicyAlphaOptions=true|false (ALPHA - default=false) kube:CPUManagerPolicyBetaOptions=true|false (BETA - default=true) kube:CRDObservedGenerationTracking=true|false (BETA - default=false) kube:CSIServiceAccountTokenSecrets=true|false (BETA - default=true) kube:CSIVolumeHealth=true|false (ALPHA - default=false) kube:ClearingNominatedNodeNameAfterBinding=true|false (BETA - default=true) kube:ClientsAllowCBOR=true|false (ALPHA - default=false) kube:ClientsPreferCBOR=true|false (ALPHA - default=false) kube:CloudControllerManagerWatchBasedRoutesReconciliation=true|false (ALPHA - default=false) kube:CloudControllerManagerWebhook=true|false (ALPHA - default=false) kube:ClusterTrustBundle=true|false (BETA - default=false) kube:ClusterTrustBundleProjection=true|false (BETA - default=false) kube:ComponentFlagz=true|false (ALPHA - default=false) kube:ComponentStatusz=true|false (ALPHA - default=false) kube:ConcurrentWatchObjectDecode=true|false (BETA - default=false) kube:ConstrainedImpersonation=true|false (ALPHA - default=false) kube:ContainerCheckpoint=true|false (BETA - default=true) kube:ContainerRestartRules=true|false (BETA - default=true) kube:ContainerStopSignals=true|false (ALPHA - default=false) kube:ContextualLogging=true|false (BETA - default=true) kube:CoordinatedLeaderElection=true|false (BETA - default=false) kube:CrossNamespaceVolumeDataSource=true|false (ALPHA - default=false) kube:CustomCPUCFSQuotaPeriod=true|false (ALPHA - default=false) kube:DRAAdminAccess=true|false (BETA - default=true) kube:DRAConsumableCapacity=true|false (ALPHA - default=false) kube:DRADeviceBindingConditions=true|false (ALPHA - default=false) kube:DRADeviceTaintRules=true|false (ALPHA - default=false) kube:DRADeviceTaints=true|false (ALPHA - default=false) kube:DRAExtendedResource=true|false (ALPHA - default=false) kube:DRAPartitionableDevices=true|false (ALPHA - default=false) kube:DRAPrioritizedList=true|false (BETA - default=true) kube:DRAResourceClaimDeviceStatus=true|false (BETA - default=true) kube:DRASchedulerFilterTimeout=true|false (BETA - default=true) kube:DeclarativeValidation=true|false (BETA - default=true) kube:DeclarativeValidationTakeover=true|false (BETA - default=false) kube:DeploymentReplicaSetTerminatingReplicas=true|false (BETA - default=true) kube:DetectCacheInconsistency=true|false (BETA - default=true) kube:DisableCPUQuotaWithExclusiveCPUs=true|false (BETA - default=true) kube:EnvFiles=true|false (BETA - default=true) kube:EventedPLEG=true|false (ALPHA - default=false) kube:ExternalServiceAccountTokenSigner=true|false (BETA - default=true) kube:GangScheduling=true|false (ALPHA - default=false) kube:GenericWorkload=true|false (ALPHA - default=false) kube:GracefulNodeShutdown=true|false (BETA - default=true) kube:GracefulNodeShutdownBasedOnPodPriority=true|false (BETA - default=true) kube:HPAConfigurableTolerance=true|false (BETA - default=true) kube:HPAScaleToZero=true|false (ALPHA - default=false) kube:HostnameOverride=true|false (BETA - default=true) kube:ImageVolume=true|false (BETA - default=true) kube:InOrderInformers=true|false (BETA - default=true) kube:InOrderInformersBatchProcess=true|false (BETA - default=true) kube:InPlacePodLevelResourcesVerticalScaling=true|false (ALPHA - default=false) kube:InPlacePodVerticalScalingExclusiveCPUs=true|false (ALPHA - default=false) kube:InPlacePodVerticalScalingExclusiveMemory=true|false (ALPHA - default=false) kube:InTreePluginPortworxUnregister=true|false (ALPHA - default=false) kube:KubeletCrashLoopBackOffMax=true|false (BETA - default=true) kube:KubeletEnsureSecretPulledImages=true|false (BETA - default=true) kube:KubeletFineGrainedAuthz=true|false (BETA - default=true) kube:KubeletInUserNamespace=true|false (ALPHA - default=false) kube:KubeletPSI=true|false (BETA - default=true) kube:KubeletPodResourcesDynamicResources=true|false (BETA - default=true) kube:KubeletPodResourcesGet=true|false (BETA - default=true) kube:KubeletSeparateDiskGC=true|false (BETA - default=true) kube:KubeletServiceAccountTokenForCredentialProviders=true|false (BETA - default=true) kube:ListFromCacheSnapshot=true|false (BETA - default=true) kube:LocalStorageCapacityIsolationFSQuotaMonitoring=true|false (BETA - default=false) kube:LoggingAlphaOptions=true|false (ALPHA - default=false) kube:LoggingBetaOptions=true|false (BETA - default=true) kube:MatchLabelKeysInPodTopologySpread=true|false (BETA - default=true) kube:MatchLabelKeysInPodTopologySpreadSelectorMerge=true|false (BETA - default=true) kube:MaxUnavailableStatefulSet=true|false (BETA - default=true) kube:MemoryQoS=true|false (ALPHA - default=false) kube:MutableCSINodeAllocatableCount=true|false (BETA - default=true) kube:MutablePVNodeAffinity=true|false (ALPHA - default=false) kube:MutablePodResourcesForSuspendedJobs=true|false (ALPHA - default=false) kube:MutableSchedulingDirectivesForSuspendedJobs=true|false (ALPHA - default=false) kube:MutatingAdmissionPolicy=true|false (BETA - default=false) kube:NodeDeclaredFeatures=true|false (ALPHA - default=false) kube:NodeLogQuery=true|false (BETA - default=false) kube:NominatedNodeNameForExpectation=true|false (BETA - default=true) kube:OpenAPIEnums=true|false (BETA - default=true) kube:OpportunisticBatching=true|false (BETA - default=true) kube:PodAndContainerStatsFromCRI=true|false (ALPHA - default=false) kube:PodCertificateRequest=true|false (BETA - default=false) kube:PodDeletionCost=true|false (BETA - default=true) kube:PodLevelResources=true|false (BETA - default=true) kube:PodLogsQuerySplitStreams=true|false (ALPHA - default=false) kube:PodReadyToStartContainersCondition=true|false (BETA - default=true) kube:PodTopologyLabelsAdmission=true|false (BETA - default=true) kube:PortForwardWebsockets=true|false (BETA - default=true) kube:PreventStaticPodAPIReferences=true|false (BETA - default=true) kube:ProcMountType=true|false (BETA - default=true) kube:QOSReserved=true|false (ALPHA - default=false) kube:ReduceDefaultCrashLoopBackOffDecay=true|false (ALPHA - default=false) kube:RelaxedServiceNameValidation=true|false (ALPHA - default=false) kube:ReloadKubeletServerCertificateFile=true|false (BETA - default=true) kube:RemoteRequestHeaderUID=true|false (BETA - default=true) kube:ResourceHealthStatus=true|false (ALPHA - default=false) kube:RestartAllContainersOnContainerExits=true|false (ALPHA - default=false) kube:RotateKubeletServerCertificate=true|false (BETA - default=true) kube:RuntimeClassInImageCriApi=true|false (ALPHA - default=false) kube:SELinuxChangePolicy=true|false (BETA - default=true) kube:SELinuxMount=true|false (BETA - default=false) kube:SELinuxMountReadWriteOncePod=true|false (BETA - default=true) kube:SchedulerAsyncAPICalls=true|false (BETA - default=true) kube:SchedulerAsyncPreemption=true|false (BETA - default=true) kube:SchedulerPopFromBackoffQ=true|false (BETA - default=true) kube:ServiceAccountNodeAudienceRestriction=true|false (BETA - default=true) kube:SizeBasedListCostEstimate=true|false (BETA - default=true) kube:StatefulSetSemanticRevisionComparison=true|false (BETA - default=true) kube:StorageCapacityScoring=true|false (ALPHA - default=false) kube:StorageVersionAPI=true|false (ALPHA - default=false) kube:StorageVersionHash=true|false (BETA - default=true) kube:StorageVersionMigrator=true|false (BETA - default=false) kube:StrictIPCIDRValidation=true|false (ALPHA - default=false) kube:StructuredAuthenticationConfigurationEgressSelector=true|false (BETA - default=true) kube:StructuredAuthenticationConfigurationJWKSMetrics=true|false (BETA - default=true) kube:TaintTolerationComparisonOperators=true|false (ALPHA - default=false) kube:TokenRequestServiceAccountUIDValidation=true|false (BETA - default=true) kube:TopologyManagerPolicyAlphaOptions=true|false (ALPHA - default=false) kube:TopologyManagerPolicyBetaOptions=true|false (BETA - default=true) kube:TranslateStreamCloseWebsocketRequests=true|false (BETA - default=true) kube:UnauthenticatedHTTP2DOSMitigation=true|false (BETA - default=true) kube:UnknownVersionInteroperabilityProxy=true|false (ALPHA - default=false) kube:UserNamespacesHostNetworkSupport=true|false (ALPHA - default=false) kube:UserNamespacesSupport=true|false (BETA - default=true) kube:VolumeLimitScaling=true|false (ALPHA - default=false) kube:WatchCacheInitializationPostStartHook=true|false (BETA - default=false) kube:WatchList=true|false (BETA - default=true) kube:WatchListClient=true|false (BETA - default=true) kube:WindowsCPUAndMemoryAffinity=true|false (ALPHA - default=false) kube:WindowsGracefulNodeShutdown=true|false (BETA - default=true)

-h, --help=false
    help for kube-scheduler

--http2-max-streams-per-connection=0
    The limit that the server gives to clients for the maximum number of streams in an HTTP/2 connection. Zero means to use golang's default.

--kube-api-burst=100
    DEPRECATED: burst to use while talking with kubernetes apiserver. This parameter is ignored if a config file is specified in --config.

--kube-api-content-type="application/vnd.kubernetes.protobuf"
    DEPRECATED: content type of requests sent to apiserver. This parameter is ignored if a config file is specified in --config.

--kube-api-qps=50
    DEPRECATED: QPS to use while talking with kubernetes apiserver. This parameter is ignored if a config file is specified in --config.

--kubeconfig=""
    DEPRECATED: path to kubeconfig file with authorization and master location information. This parameter is ignored if a config file is specified in --config.

--leader-elect=true
    Start a leader election client and gain leadership before executing the main loop. Enable this when running replicated components for high availability.

--leader-elect-lease-duration=15s
    The duration that non-leader candidates will wait after observing a leadership renewal until attempting to acquire leadership of a led but unrenewed leader slot. This is effectively the maximum duration that a leader can be stopped before it is replaced by another candidate. This is only applicable if leader election is enabled.

--leader-elect-renew-deadline=10s
    The interval between attempts by the acting master to renew a leadership slot before it stops leading. This must be less than the lease duration. This is only applicable if leader election is enabled.

--leader-elect-resource-lock="leases"
    The type of resource object that is used for locking during leader election. Supported options are 'leases'.

--leader-elect-resource-name="kube-scheduler"
    The name of resource object that is used for locking during leader election.

--leader-elect-resource-namespace="kube-system"
    The namespace of resource object that is used for locking during leader election.

--leader-elect-retry-period=2s
    The duration the clients should wait between attempting acquisition and renewal of a leadership. This is only applicable if leader election is enabled.

--log-flush-frequency=5s
    Maximum number of seconds between log flushes

--log-text-info-buffer-size=0
    [Alpha] In text format with split output streams, the info messages can be buffered for a while to increase performance. The default value of zero bytes disables buffering. The size can be specified as number of bytes (512), multiples of 1000 (1K), multiples of 1024 (2Ki), or powers of those (3M, 4G, 5Mi, 6Gi). Enable the LoggingAlphaOptions feature gate to use this.

--log-text-split-stream=false
    [Alpha] In text format, write error messages to stderr and info messages to stdout. The default is to write a single stream to stdout. Enable the LoggingAlphaOptions feature gate to use this.

--logging-format="text"
    Sets the log format. Permitted formats: "text".

--master=""
    The address of the Kubernetes API server (overrides any value in kubeconfig)

--min-compatibility-version=[]
    The min version of control plane components the server should be compatible with. Must be less or equal to the emulated-version. Version format could only be major.minor, for example: '--min-compatibility-version=wardle=1.2,kube=1.31'. Options are: kube=1.32..1.35(default:1.34) If the component is not specified, defaults to "kube"

--permit-address-sharing=false
    If true, SO_REUSEADDR will be used when binding the port. This allows binding to wildcard IPs like 0.0.0.0 and specific IPs in parallel, and it avoids waiting for the kernel to release sockets in TIME_WAIT state. [default=false]

--permit-port-sharing=false
    If true, SO_REUSEPORT will be used when binding the port, which allows more than one instance to bind on the same address and port. [default=false]

--pod-max-in-unschedulable-pods-duration=5m0s
    DEPRECATED: the maximum time a pod can stay in unschedulablePods. If a pod stays in unschedulablePods for longer than this value, the pod will be moved from unschedulablePods to backoffQ or activeQ. This flag is deprecated and will be removed in a future version.

--profiling=true
    DEPRECATED: enable profiling via web interface host:port/debug/pprof/. This parameter is ignored if a config file is specified in --config.

--requestheader-allowed-names=[]
    List of client certificate common names to allow to provide usernames in headers specified by --requestheader-username-headers. If empty, any client certificate validated by the authorities in --requestheader-client-ca-file is allowed.

--requestheader-client-ca-file=""
    Root certificate bundle to use to verify client certificates on incoming requests before trusting usernames in headers specified by --requestheader-username-headers. WARNING: generally do not depend on authorization being already done for incoming requests.

--requestheader-extra-headers-prefix=[x-remote-extra-]
    List of request header prefixes to inspect. X-Remote-Extra- is suggested.

--requestheader-group-headers=[x-remote-group]
    List of request headers to inspect for groups. X-Remote-Group is suggested.

--requestheader-uid-headers=[]
    List of request headers to inspect for UIDs. X-Remote-Uid is suggested. Requires the RemoteRequestHeaderUID feature to be enabled.

--requestheader-username-headers=[x-remote-user]
    List of request headers to inspect for usernames. X-Remote-User is common.

--secure-port=10259
    The port on which to serve HTTPS with authentication and authorization. If 0, don't serve HTTPS at all.

--show-hidden-metrics-for-version=""
    The previous version for which you want to show hidden metrics. Only the previous minor version is meaningful, other values will not be allowed. The format is ., e.g.: '1.16'. The purpose of this format is make sure you have the opportunity to notice if the next release hides additional metrics, rather than being surprised when they are permanently removed in the release after that.

--tls-cert-file=""
    File containing the default x509 Certificate for HTTPS. (CA cert, if any, concatenated after server cert). If HTTPS serving is enabled, and --tls-cert-file and --tls-private-key-file are not provided, a self-signed certificate and key are generated for the public address and saved to the directory specified by --cert-dir.

--tls-cipher-suites=[]
    Comma-separated list of cipher suites for the server. If omitted, the default Go cipher suites will be used. Preferred values: TLS_AES_128_GCM_SHA256, TLS_AES_256_GCM_SHA384, TLS_CHACHA20_POLY1305_SHA256, TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA, TLS_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256, TLS_ECDHE_ECDSA_WITH_AES_256_CBC_SHA, TLS_ECDHE_ECDSA_WITH_AES_256_GCM_SHA384, TLS_ECDHE_ECDSA_WITH_CHACHA20_POLY1305, TLS_ECDHE_ECDSA_WITH_CHACHA20_POLY1305_SHA256, TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA, TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256, TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA, TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384, TLS_ECDHE_RSA_WITH_CHACHA20_POLY1305, TLS_ECDHE_RSA_WITH_CHACHA20_POLY1305_SHA256. Insecure values: TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA256, TLS_ECDHE_ECDSA_WITH_RC4_128_SHA, TLS_ECDHE_RSA_WITH_3DES_EDE_CBC_SHA, TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA256, TLS_ECDHE_RSA_WITH_RC4_128_SHA, TLS_RSA_WITH_3DES_EDE_CBC_SHA, TLS_RSA_WITH_AES_128_CBC_SHA, TLS_RSA_WITH_AES_128_CBC_SHA256, TLS_RSA_WITH_AES_128_GCM_SHA256, TLS_RSA_WITH_AES_256_CBC_SHA, TLS_RSA_WITH_AES_256_GCM_SHA384, TLS_RSA_WITH_RC4_128_SHA.

--tls-min-version=""
    Minimum TLS version supported. Possible values: VersionTLS10, VersionTLS11, VersionTLS12, VersionTLS13

--tls-private-key-file=""
    File containing the default x509 private key matching --tls-cert-file.

--tls-sni-cert-key=[]
    A pair of x509 certificate and private key file paths, optionally suffixed with a list of domain patterns which are fully qualified domain names, possibly with prefixed wildcard segments. The domain patterns also allow IP addresses, but IPs should only be used if the apiserver has visibility to the IP address requested by a client. If no domain patterns are provided, the names of the certificate are extracted. Non-wildcard matches trump over wildcard matches, explicit domain patterns trump over extracted names. For multiple key/certificate pairs, use the --tls-sni-cert-key multiple times. Examples: "example.crt,example.key" or "foo.crt,foo.key:*.foo.com,foo.com".

-v, --v=0
    number for the log level verbosity

--version=false
    --version, --version=raw prints version information and quits; --version=vX.Y.Z... sets the reported version

--vmodule=
    comma-separated list of pattern=N settings for file-filtered logging (only works for text log format)

--write-config-to=""
    If set, write the configuration values to this file and exit.

HISTORY
January 2015, Originally compiled by Eric Paris (eparis at redhat dot com) based on the kubernetes source material, but hopefully they have been automatically generated since!